/* TaskExample01.ino
 * Naive implementation of multi-function sketch
 * Will NOT function as intended!
 */

int onThreshold = 700;
int offThreshold = 500;

int ledPin = 13;

int rPin = 5;
int gPin = 9;
int bPin = 6;

int outputPin = 7;

int analogPin = A0;

int analogValue;

void setup(void)
{
  pinMode(ledPin, OUTPUT);
  pinMode(rPin, OUTPUT);
  pinMode(gPin, OUTPUT);
  pinMode(bPin, OUTPUT);
  pinMode(outputPin, OUTPUT);

  pinMode(analogPin, INPUT);

  digitalWrite(outputPin, LOW);

  Serial.begin(115200);
}

void loop(void)
{

  /* We want the LED to blink every 500 ms */
  digitalWrite(ledPin, HIGH);
  delay(500);
  digitalWrite(ledPin, LOW);
  delay(500);

  // !! Already used up 1000ms here !! 
  /* We want to read the analog voltage every 100ms */
  analogValue = analogRead(analogPin);
  if (analogValue < offThreshold)
  {
    digitalWrite(outputPin, LOW);
  }
  else if (analogValue > onThreshold)
  {
    digitalWrite(outputPin, HIGH);
  }
  delay(100);

  // !! Already used up 1100ms here !! 

  /* We want to check for new serial data every 200ms */
  if (Serial.available() > 0)
  {
    int r = Serial.parseInt();
    int g = Serial.parseInt();
    int b = Serial.parseInt();

    analogWrite(rPin, r);
    analogWrite(gPin, g);
    analogWrite(bPin, b);
    
    // Discard any other characters
    while (Serial.available() > 0) { Serial.read(); }
  }
  delay(200);

  // !! Already used up 1300ms here !! 

  /* We want to send the latest analog reading back every 1000ms*/
  //Serial.print("Analog read: ");
  //Serial.println(analogValue);
  delay(1000);

  // !! Already used up 2300ms here !! 
}


